/*

  HelloX.C
  ========
  (c) Copyright Paul Griffiths 1999
  Email: mail@paulgriffiths.net

  "Hello, World!", X Window System style.

*/


#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <pcsclite.h>
#include <winscard.h>
#include <stdlib.h>


/*  Global variables  */

Display *     display;
int           screen_num;
static char * appname;
SCARDHANDLE hCard; SCARDCONTEXT hContext;
SCARD_READERSTATE_A rgReaderStates[1];
unsigned long dwReaderLen, dwState, dwProt, dwAtrLen;
unsigned long dwSendLength, dwRecvLength, dwPref, dwReaders;
char *pcReaders, *mszReaders;
unsigned char pbAtr[MAX_ATR_SIZE];
const char * mszGroups;
long rv;
int i, p, iReader;
int iList[16];

int initialisereader() {
  rv = SCardEstablishContext( SCARD_SCOPE_SYSTEM, NULL, NULL, &hContext );

  if ( rv != SCARD_S_SUCCESS ) {
    return -1;
  }

  rv = SCardGetStatusChange( hContext, INFINITE, 0, 0 );

  if ( rv != SCARD_S_SUCCESS ) {
    SCardReleaseContext( hContext );
    return -1;
  }
  mszGroups = 0;
  rv = SCardListReaders( hContext, mszGroups, 0, &dwReaders );

  if ( rv != SCARD_S_SUCCESS ) {
    SCardReleaseContext( hContext );
    return -1;
  }

  mszReaders = (char *)malloc(sizeof(char)*dwReaders);
  rv = SCardListReaders( hContext, mszGroups, mszReaders, &dwReaders );

  if ( rv != SCARD_S_SUCCESS ) {
    SCardReleaseContext( hContext );
    return -1;
  }

  /* Have to understand the multi-string here */
  p = 0;
  for ( i=0; i < dwReaders - 1; i++ ) {
    ++p;
    iList[p] = i;
    while ( mszReaders[++i] != 0 );
  }

#ifdef REPEAT_TEST
  if ( t==0 ) { 
#endif

    iReader = 1;

#ifdef REPEAT_TEST
  t=1; 
  }    
#endif


}

int waitforcard() {
  BYTE pbRecvBuffer[257];
  DWORD dwSendLength; 
  DWORD pcbRecvLength;
  SCARD_IO_REQUEST pioRecvPci;
  BYTE pbSendBuffer[] = { 0xa4, 0xb0, 0x83, 0x08, 0x07 };
  SCARD_IO_REQUEST pioSendPci;
  int i;

  rgReaderStates[0].szReader       = &mszReaders[iList[iReader]];
  rgReaderStates[0].dwCurrentState = SCARD_STATE_EMPTY;

  rv = SCardGetStatusChange( hContext, INFINITE, rgReaderStates, 1 );

  rv = SCardConnect(hContext, &mszReaders[iList[iReader]], 
		    SCARD_SHARE_SHARED, SCARD_PROTOCOL_T0 | SCARD_PROTOCOL_T1,
		    &hCard, &dwPref);

  rv = SCardBeginTransaction( hCard );

  dwSendLength = sizeof(pbSendBuffer);
  pcbRecvLength = sizeof(pbRecvBuffer);
  pioSendPci.dwProtocol = dwPref;
  pioSendPci.cbPciLength = 8; 

  rv = SCardTransmit( hCard, &pioSendPci, pbSendBuffer,
		      dwSendLength, &pioRecvPci, pbRecvBuffer,
		      &pcbRecvLength);  

  pbRecvBuffer[pcbRecvLength] = '\0';

  rv = SCardEndTransaction( hCard, SCARD_UNPOWER_CARD );

  SCardDisconnect( hCard, SCARD_RESET_CARD );

  i = 0;
  while(pbRecvBuffer[i] != '\0') {
    XTestFakeKeyEvent(display,
		      XKeysymToKeycode(display,pbRecvBuffer[i]),
		      True,0);
    XTestFakeKeyEvent(display,
		      XKeysymToKeycode(display,pbRecvBuffer[i]),
		      False,0);
    XFlush(display);
    i++;
  }
 
  rgReaderStates[0].dwCurrentState = SCARD_STATE_PRESENT;
  rv = SCardGetStatusChange( hContext, INFINITE, rgReaderStates, 1 );

}

/*  main() function  */

int main( int argc, char * argv[] ) {

    /*  Window variables  */

    Window       win;
    int          x, y;
    unsigned int width, height;
    unsigned int border_width;
    char *       window_name = "Hello, X Window System!";
    char *       icon_name   = "HelloX";


    /*  Display variables  */

    char *       display_name = NULL;
    unsigned int display_width, display_height;
    

    /*  Miscellaneous X variables  */

    XSizeHints *  size_hints;
    XWMHints   *  wm_hints;
    XClassHint *  class_hints;
    XTextProperty windowName, iconName;
    XEvent        report;
    XFontStruct * font_info;
    XGCValues     values;
    GC            gc;
    
    appname = argv[0];


    /*  Allocate memory for our structures  */

    if ( !( size_hints  = XAllocSizeHints() ) || 
         !( wm_hints    = XAllocWMHints()   ) ||
         !( class_hints = XAllocClassHint() )    ) {
        fprintf(stderr, "%s: couldn't allocate memory.\n", appname);
        exit(EXIT_FAILURE);
    }


    /*  Connect to X server  */

    if ( (display = XOpenDisplay(display_name)) == NULL ) {
        fprintf(stderr, "%s: couldn't connect to X server %s\n",
                appname, display_name);
        exit(EXIT_FAILURE);
    }

    initialisereader();

    /* Enter event loop */
    while ( 1 ) {

      waitforcard();

      // XNextEvent(display, &report);
    }

    XCloseDisplay(display);
    
    return EXIT_SUCCESS;   /*  We shouldn't get here  */
}
